import React from "react";
/**
 * @internal
 */
export type IContextStoreProvider<T> = React.FC<{
    value: T;
    children: React.ReactNode;
}>;
/**
 * @internal
 */
export type IContextStoreSelector<T, SelectorResult> = (state: T) => SelectorResult;
/**
 * @internal
 */
export type IUseContextStore<T, IsOptional = false> = <SelectorResult>(selector?: IContextStoreSelector<T, SelectorResult>, equalityFn?: (a: SelectorResult, b: SelectorResult) => boolean) => IsOptional extends false ? SelectorResult : SelectorResult | undefined;
/**
 * @internal
 */
export type IContextStore<T> = IContextStoreProvider<T> & {
    useContextStore: IUseContextStore<T>;
    useContextStoreOptional: IUseContextStore<T, true>;
    createSelector: <SelectorResult>(selector: IContextStoreSelector<T, SelectorResult>) => IContextStoreSelector<T, SelectorResult>;
};
/**
 * Creates a context store.
 * This allows components inside the context to select slices of the store and only rerender when the slice changes.
 *
 * Provides a Provider and a slice selector hook.
 *
 * @internal
 */
export declare const createContextStore: <T>(name: string) => IContextStore<T>;
//# sourceMappingURL=contextStore.d.ts.map